VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "df3 Maker"
   ClientHeight    =   2055
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   3255
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2055
   ScaleWidth      =   3255
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Loaded Data"
      Height          =   1695
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   3255
      Begin MSComDlg.CommonDialog CD2 
         Left            =   2520
         Top             =   840
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   393216
      End
      Begin MSComDlg.CommonDialog CD1 
         Left            =   2520
         Top             =   240
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   393216
      End
      Begin VB.Label Label2 
         Caption         =   "No File Opened"
         Height          =   255
         Index           =   3
         Left            =   1560
         TabIndex        =   10
         Top             =   360
         Width           =   1335
      End
      Begin VB.Label Label2 
         Caption         =   "0"
         Height          =   255
         Index           =   2
         Left            =   1560
         TabIndex        =   9
         Top             =   1200
         Width           =   1095
      End
      Begin VB.Label Label2 
         Caption         =   "0"
         Height          =   255
         Index           =   1
         Left            =   1560
         TabIndex        =   8
         Top             =   960
         Width           =   1095
      End
      Begin VB.Label Label2 
         Caption         =   "0"
         Height          =   255
         Index           =   0
         Left            =   1560
         TabIndex        =   7
         Top             =   720
         Width           =   1095
      End
      Begin VB.Label Label1 
         Caption         =   "File Loaded"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   6
         Top             =   360
         Width           =   1095
      End
      Begin VB.Label Label1 
         Caption         =   "Z Dimension"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   5
         Top             =   1200
         Width           =   1095
      End
      Begin VB.Label Label1 
         Caption         =   "Y Dimension"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   4
         Top             =   960
         Width           =   1095
      End
      Begin VB.Label Label1 
         Caption         =   "X Dimension"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   3
         Top             =   720
         Width           =   1095
      End
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Save df3..."
      Enabled         =   0   'False
      Height          =   255
      Index           =   1
      Left            =   1800
      TabIndex        =   1
      Top             =   1800
      Width           =   1455
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Load ASCII..."
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   1800
      Width           =   1455
   End
   Begin VB.Menu Filemnu 
      Caption         =   "&File"
      Begin VB.Menu Loadmnu 
         Caption         =   "&Load ASCII..."
         Shortcut        =   ^L
      End
      Begin VB.Menu Savemnu 
         Caption         =   "&Save df3..."
         Shortcut        =   ^S
      End
      Begin VB.Menu sepmnu 
         Caption         =   "-"
      End
      Begin VB.Menu Quitmnu 
         Caption         =   "&Quit"
         Shortcut        =   ^Q
      End
   End
   Begin VB.Menu Aboutmnu 
      Caption         =   "&About"
      Begin VB.Menu Splashmnu 
         Caption         =   "Program Info"
      End
      Begin VB.Menu sep2mnu 
         Caption         =   "-"
      End
      Begin VB.Menu Infomnu 
         Caption         =   "Input file format"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim InputFile As String
Dim OutputFile As String
Dim df3Array() As Byte
Dim XDim As Long
Dim YDim As Long
Dim ZDim As Long


Private Sub Command1_Click(Index As Integer)

Select Case Index
    Case 0
        Call LoadFile
    Case 1
        Call SaveFile
End Select

End Sub

Private Sub Form_Load()
ReDim df3Array(0, 0, 0)
End Sub

Private Sub Infomnu_Click()

Dim MsgTxt As String
Dim Crutch As Long

MsgTxt = "df3 Maker File Input Information" & Chr(13)
MsgTxt = MsgTxt & "" & Chr(13)
MsgTxt = MsgTxt & "df3 Maker requires input data from a comma delimited ASCII file." & Chr(13)
MsgTxt = MsgTxt & "The default extention for this file is txt, but any file can be" & Chr(13)
MsgTxt = MsgTxt & "opened. The first three numbers in the input file must contain the" & Chr(13)
MsgTxt = MsgTxt & "number of bins (referred to as voxels in the POV-Ray documentation)" & Chr(13)
MsgTxt = MsgTxt & "for the x, y, and z axes. These dimensions must be positive integers." & Chr(13)
MsgTxt = MsgTxt & "After this, integer data ranging from 0 to 255, in order of" & Chr(13)
MsgTxt = MsgTxt & "increasing x, y and z follow. Below is an example of a 4x3x2 input file." & Chr(13)
MsgTxt = MsgTxt & "" & Chr(13)
MsgTxt = MsgTxt & "4,3,2" & Chr(13)
MsgTxt = MsgTxt & "0,100,100,0" & Chr(13)
MsgTxt = MsgTxt & "50,255,255,50" & Chr(13)
MsgTxt = MsgTxt & "0,100,100,0" & Chr(13)
MsgTxt = MsgTxt & "0,50,50,0" & Chr(13)
MsgTxt = MsgTxt & "25,100,100,25" & Chr(13)
MsgTxt = MsgTxt & "0,25,25,0" & Chr(13)
MsgTxt = MsgTxt & "" & Chr(13)
MsgTxt = MsgTxt & "Common errors include not delimiting properly, not including enough" & Chr(13)
MsgTxt = MsgTxt & "data, or incorrectly assigning the axis sizes." & Chr(13)

Crutch = MsgBox(MsgTxt, vbOKOnly, "File Input Format")

End Sub

Private Sub Loadmnu_Click()
Call LoadFile
End Sub

Private Sub Quitmnu_Click()
End
End Sub

Public Sub LoadFile()

Dim FileNum As Long
Dim i As Long
Dim j As Long
Dim k As Long
Dim ReadData As Long

On Error GoTo EH1

CD1.CancelError = True
CD1.Filter = "Text Files (*.txt)|*.txt|All Files (*.*)|*.*"
CD1.ShowOpen

InputFile = CD1.filename

Label2(3).Caption = CD1.FileTitle

Command1(1).Enabled = True

FileNum = FreeFile

On Error GoTo EH2

Open InputFile For Input As FileNum

Input #FileNum, XDim, YDim, ZDim

Label2(0).Caption = XDim
Label2(1).Caption = YDim
Label2(2).Caption = ZDim

ReDim df3Array(XDim - 1, YDim - 1, ZDim - 1)

For i = 0 To ZDim - 1
    For j = 0 To YDim - 1
        For k = 0 To XDim - 1
            Input #FileNum, ReadData
            If ReadData < 0 Then ReadData = 0
            If ReadData > 255 Then ReadData = 255
            ReadData = CByte(ReadData)
            df3Array(k, j, i) = ReadData
        Next k
    Next j
Next i

Close FileNum

Exit Sub
EH1:
Exit Sub

EH2:
MsgBox ("There was an error in the input file!" & Chr(13) & "Check it's formatting.")
Command1(1).Enabled = False
Label2(3).Caption = "Error!"
Exit Sub

End Sub

Public Sub SaveFile()

Dim FileNum As Long
Dim i As Long
Dim j As Long
Dim k As Long

Dim HBx As Byte
Dim HBy As Byte
Dim HBz As Byte
Dim LBx As Byte
Dim LBy As Byte
Dim LBz As Byte

On Error GoTo EH1

CD2.CancelError = True
CD2.Filter = "df3 Files (*.df3)|*.df3"
CD2.ShowSave

OutputFile = CD2.filename

FileNum = FreeFile

On Error GoTo EH2

HBx = CByte(Int(XDim / 256))
LBx = CByte(XDim - Int(XDim / 256))
HBy = CByte(Int(YDim / 256))
LBy = CByte(YDim - Int(YDim / 256))
HBz = CByte(Int(ZDim / 256))
LBz = CByte(ZDim - Int(ZDim / 256))

Open OutputFile For Binary As FileNum

Put FileNum, , HBx
Put FileNum, , LBx
Put FileNum, , HBy
Put FileNum, , LBy
Put FileNum, , HBz
Put FileNum, , LBz

For i = 0 To ZDim - 1
    For j = 0 To YDim - 1
        For k = 0 To XDim - 1
            Put FileNum, , df3Array(k, j, i)
        Next k
    Next j
Next i

Close FileNum

MsgBox ("File Saved!")

Exit Sub
EH1:
Exit Sub

EH2:
Exit Sub

End Sub

Private Sub Savemnu_Click()
Call SaveFile
End Sub

Private Sub Splashmnu_Click()

Dim MsgTxt As String
Dim Crutch As Long

MsgTxt = "df3 Maker" & Chr(13)
MsgTxt = MsgTxt & "By Mark Lewin" & Chr(13)
MsgTxt = MsgTxt & "" & Chr(13)
MsgTxt = MsgTxt & "A small program that will write df3 files" & Chr(13)
MsgTxt = MsgTxt & "(POV-Ray media density files) from data" & Chr(13)
MsgTxt = MsgTxt & "contained in a delimited text file." & Chr(13)
MsgTxt = MsgTxt & "See About...Input file format for more" & Chr(13)
MsgTxt = MsgTxt & "information regarding input specifics." & Chr(13)
MsgTxt = MsgTxt & "" & Chr(13)
MsgTxt = MsgTxt & "(c) Mark Lewin, 14-6-2000" & Chr(13)

Crutch = MsgBox(MsgTxt, vbOKOnly, "df3 Maker")

End Sub
